/********************************************************************************
*                                                                     
*       Copyright (C) 2008 Freescale Semiconductor, Inc.              
*       All Rights Reserved								              
*														              
* Filename:     main.c                
*														              
* Revision:      										              
*														              
* Functions:    Includes main function
*         
* Description:  
*
* Notes:        
*
*********************************************************************************/

#include <hidef.h> /* for EnableInterrupts macro */
#include "ADC16.h"
#include "derivative.h" /* include peripheral declarations */
#include "porting_support.h"
#include "ICS.h"
#include "sci_drv.h"
#include "interrupts.h"
#include <string.h> /* include peripheral declarations */
#include "LCD_drv.h" /* LCD assignments */

/*********************************** Defines ***********************************/

#define BUSCLK_FREQ_KHZ		20000L	
#define TERMINAL_BAUD_RATE	9600 
#define SCIBD_BAUD_RATE ((BUSCLK_FREQ_KHZ * 10) / (16 * (TERMINAL_BAUD_RATE/100)))

#define ON  0xFF
#define OFF 0x00
#define SET 0xFF
#define CLEAR 0x00

/************************** Function Declarations ******************************/

void System_Init(void);
void WaitMicroSecondsInt (unsigned char delay_us)    ;
void DataToPort_LSB_First(unsigned short);
void DataToLCD (unsigned short adc_data);   
void InitPortInterface(void);
void InitLCD(void); 
void SetAlpha(char alphanum, char data);
void ClearDisplay(void);
void SetDisplay(void); 
void Colon(char Cnum,char ON_OFF) ;
void Period(char Cnum,char ON_OFF) ;
void Battery(char ON_OFF) ;
void Batlevel_1(char ON_OFF) ;
void Batlevel_2(char ON_OFF) ;
void Batlevel_3(char ON_OFF) ;
void Batlevel_4(char ON_OFF) ;
void Cold(char ON_OFF) ;
void Heat(char ON_OFF) ;

void Freescale(char ON_OFF); 
void WriteDirection(unsigned char direction);

volatile unsigned char channel = 0;
volatile unsigned char channel_adc = 0;
unsigned short ADC_Conversion(unsigned char);
volatile unsigned char state = 0;
volatile unsigned char sec = 5;
volatile unsigned char tsec = 5;
volatile unsigned char mins = 9;
volatile unsigned char tmins = 5;
volatile unsigned char hour = 3;
volatile unsigned char thour= 2;
volatile unsigned char day= 1;
volatile unsigned char tday= 3;
volatile unsigned char month= 2;
volatile unsigned char tmonth= 1;
volatile unsigned char year= 8;
volatile unsigned char tyear= 0;
volatile unsigned char hyear= 0;
volatile unsigned char thyear= 2;
volatile unsigned char textday= 2;


/************************** variable Declarations ******************************/


/*unsigned char *columns[35] = {
             ((char*)COL1),((char*)COL2),((char*)COL3),((char*)COL4),((char*)COL5),
             ((char*)COL6),((char*)COL7),((char*)COL8),((char*)COL9),((char*)COL10),
             ((char*)COL11),((char*)COL12),((char*)COL13),((char*)COL14),((char*)COL15),
             ((char*)COL16),((char*)COL17),((char*)COL18),((char*)COL19),((char*)COL20),
             ((char*)COL21),((char*)COL22),((char*)COL23),((char*)COL24),((char*)COL25),
             ((char*)COL26),((char*)COL27),((char*)COL28),((char*)COL29),((char*)COL30),
             ((char*)COL31),((char*)COL32),((char*)COL33),((char*)COL34),((char*)COL35)
}; 
*/
//extern  char ascii[]; 
unsigned char *string;
unsigned int length, i,j;
unsigned char column,row,trim;

/*******************************************************************************
* Function:        main
*
* Description:     
*
* Returns:         never return
*
* Notes:           
*                 
*******************************************************************************/

void main(void) {

  volatile unsigned short data;
  volatile unsigned short TEST;
  volatile unsigned short MODE;
  channel_adc = 0x04;
  TEST = DIFF_SINGLE;   /* Select Test: DIFF_SINGLE or DIFF_DIFFERENTIAL */
  MODE = MODE_16;       /* Select Conversion Mode: MODE_16, MODE_12, MODE_10, MODE_8 */
  System_Init();        /* including pin mux control, ADC channel or I/O */
  
  EnableInterrupts; /* enable interrupts */
  
  /* blank interrupt routines in interrupts.c */ 
  /* please refer to table at top of file for ADC Channel -> ADC number correlataion */
  
  /* Configure ADC1 */
  ////////////////////////////////////////////////////////////////////////////  
  // Clock Init ICS
  ////////////////////////////////////////////////////////////////////////
         ICSC2 = 0x07;
         ICSC1 = 0x00;
    /* 20MHz FEI mode */
 // ICS_Config((CLKS_FLL|IREFS_INTERNAL|IRCLKEN_ACTIVE|IREFSTEN_INTERNAL_STOP_ENABLE),
 // (BDIV_1|LP_FLL_ENABLED|EREFS_EX_CLOCK|ERCLKEN_INACTIVE|EREFSTEN_INTERNAL_STOP_DISABLE), 0xF0,(DCO_RANGE_HIGH|DCO_MAX_25)); 

     
  /* Configure SCI1 for terminal data */
  TerminalPointer = (tSCI *)SCI1;
  SCI_Config(TerminalPointer, SCIBD_BAUD_RATE);

   // Setup ADC3
  
  ADC_Init((ADLPC_NORMAL|ADIV_8|ADLSMP_LONG|MODE_16|ADICLK_BUS), (ADACKEN_DISABLED|ADHSC_HISPEED|ADLSTS_20), 0xFF, 0xFF,
  (ADTRG_SW|ACFE_DISABLED|ACFGT_LESS|ACREN_DISABLED|REFSEL_EXT), (ADCO_CONTINUOUS|AVGE_ENABLED|AVGS_32), (AIEN_OFF|DIFF_SINGLE),
  (AIEN_OFF|DIFF_SINGLE));
  
  
  ADCSC1A_ADCHA = channel_adc;       /* 0 & 4-11 */
  
  InitPortInterface();
  InitLCD();
  
  ClearDisplay();
  Freescale(ON);
Battery(ON) ;
Batlevel_1(ON) ;
Batlevel_2(ON) ;
Batlevel_3(ON) ;
Batlevel_4(ON) ;
Cold(ON) ;
Heat(ON) ;  

 
    for(;;){
      trim = 0x00 ;

      PTBD_PTBD7 = ADCSC2_ADACT;
      for(i=0x00;i< 0xff;i++) {
        VREFTRM1 = trim;
        VREFTRM2 = trim;

      	do{
  	    /* Wait for conversion to complete */
      	}while (ADCSC2_ADACT == 1); 
        PTBD_PTBD7 = ADCSC2_ADACT;
        data = ADCRA;
      
 //     DataToPort_LSB_First(data);    // Write the conversion result out to GPIO.
        DataToLCD(data);               // Write the conversion result out to LCD.
        DisplayInt(data, 4 ); 
 
        while(TODSC_QSECF == 0);
        TODSC_QSECF = 1;         
/*      while(TODSC_QSECF == 0);
        TODSC_QSECF = 1;         
        while(TODSC_QSECF == 0);
        TODSC_QSECF = 1;         
        while(TODSC_QSECF == 0);
        TODSC_QSECF = 1;       */    
           
       
        ADCSC1A_ADCHA = channel_adc;       /* 0 & 4-11 */
      }/* for i - to change trim     */
    }  /* loop forever */
} 
/*********************************** Function **********************************/
/********************************************************************
FUNCTION:		Init_Port_Interface
PURPOSE: 		Configure GPIOs for interface to PXI Hardware.
INPUTS NOTES:                
RETURNS NOTES: 
GENERAL NOTES:	Signal Descriptions:
				--------------------
				PTD[7:0] = ADC Conversion Data - low byte
				PTE[7:0] = ADC Conversion Data - high byte
				PTC5     = DUT Ready to Begin Next Ramp (Output)
				PTC4     = [PXI DAC Output] Ready for Next Conversion (Input)
				PTC2     = Data Valid trigger to HSDIO card. (Output)
********************************************************************/

void InitPortInterface(void) 
{
  
  // Configure 16 GPIOs for ADC conversion data transfer.
  PTDD = OFF;   
  PTED = OFF;           // Pre-configure data for low output.
  PTBDD = ON;           // Port B as output.
  PTDDD = ON;
  PTEDD = ON;           // Configure Ports D and E as output.
  
//  LCDC1 = 0x04;          // Full Complementary Drive Enable for Ports D and E.
//  LCDSUPPLY = 0x03;      // Vsupply = %11 for FCD on ports D and E.
//  LCDRVC = 0x08;         // Regulated Voltage disabled.
  // PTC2 is used as "Data Valid" trigger for HSDIO. 
  // PTC4 configured as an input for "Start Conversion" trigger.
  PTCDD = 0x7f;         // PTC all output except PTE4.
  PTCD = 0x00;          // Initialize PTC2 output high.
  
} /* End Init_Port_Interface */


/********************************************************************
FUNCTION: 		ADC_SingleConversion
PURPOSE: 		Adjust ADC configuration per user specification and 
				collect a single conversion result on desired channel.
INPUTS NOTES: 	Channel - DF0 ASP ADC_IN[7:0].
RETURN NOTES:
GENERAL NOTES:  Returns 16-bit result. Bits [15:12] fixed to %0000.
********************************************************************/
unsigned short ADC_Conversion(unsigned char adc_chan)
{
	unsigned short ADC_result;

	// Test flow:
	// 	1. Clear previous flags.
	//  2. Start conversion on desired channel.
	//  3. Await completion (either via interrupt or flag polling).
	//  4. Read back 16-bit conversion value and pass to calling routine.
	
// STEP 1: Clear any previous COCO flag (clears when ADC channel written).
// STEP 2: Start a single ADC conversion on the desired channel.
  ADCSC1A_ADCHA = adc_chan;

// STEP 3: Await conversion completion COCO Flag.  
  while (ADCSC1A_COCOA == 0)
  {
  /* Wait for conversion to complete */
  }

// STEP 4: Read back the conversion result.

  // No explicit averaging necessary.  MCU can be configured to average internally.
	ADC_result = (ADCRA);
	
	return ADC_result;	 /* 16-bit data */
}


/********************************************************************
FUNCTION:		WaitMicroSecondsInt
PURPOSE: 		General purpose delay for interrupt routines.
INPUT NOTES:	32-bit Integer value in microseconds.
RETURN NOTES:	n/a
GENERAL NOTES:	4 CPU cycles per loop @ 8MHz (bus, per device init).
********************************************************************/
void WaitMicroSecondsInt (unsigned char delay_us)
{
	unsigned char j;
	
	delay_us = (delay_us * 2);  
	
	for(j=0; j<delay_us; j++);  // 4 cycles per For loop taken.
	
} // End WaitMicroSecondsInt

/********************************************************************
FUNCTION: 		DataToPort_LSB_First
PURPOSE: 		 Output ADC conversion data to GPIO.
INPUT NOTES:	16-bit data 
RETURN NOTES: 
GENERAL NOTES:  Output is LSB-first
********************************************************************/
void DataToPort_LSB_First (unsigned short adc_data)   
{                             

  PTDD = (adc_data & 0x00ff); // Write lower byte of conversion value to PTD.
  PTED = ((adc_data>>8) & 0x00ff); // Write upper byte of conversion value to PTE.
 
  PTCD_PTCD2 = 1;           // Assert "Data Valid" signal.
  WaitMicroSecondsInt(10);   
  PTCD_PTCD2 = 0;           // Deassert "Data Valid" after brief delay.
  WaitMicroSecondsInt(10); 
  
}	/* end of DataToPort_LSB_First */
/********************************************************************
FUNCTION: 		DataToLCD
PURPOSE: 		 Output ADC conversion data to LCD.
INPUT NOTES:	16-bit data 
RETURN NOTES: 
GENERAL NOTES:  Output is LSB-first
********************************************************************/
void DataToLCD (unsigned short adc_data)   
{                             
    unsigned int Result;
    unsigned char channel;
    unsigned char Low;
    unsigned char High;
    

    channel =   ADCSC1A_ADCHA ;
    
    Low = channel&0x0F;
    High = (channel&0xF0)/16;

    if(Low<=0x09){
    SetAlpha(2,Low+48);
    } else    {
     SetAlpha(2,Low+55);}
     
      if(High<=0x09){
    SetAlpha(1,High+48);
    } else    {
     SetAlpha(1,High+55);}
    
    Result = adc_data;
    
    Low = Result&0x000F;
    High = (Result&0x00f0)/16;
    
    if(Low<=0x09){
    SetAlpha(6,Low+48);
    } else    {
     SetAlpha(6,Low+55);}
     
      if(High<=0x09){
    SetAlpha(5,High+48);
    } else    {
     SetAlpha(5,High+55);}

    Low = (Result&0x0F00)/256;
    High = (Result&0xF000)/4096;
    
    if(Low<=0x09){
    SetAlpha(4,Low+48);
    } else    {
     SetAlpha(4,Low+55);}
     
      if(High<=0x09){
    SetAlpha(3,High+48);
    } else    {
     SetAlpha(3,High+55);}
     
  
}	/* end of DataToPort_LSB_First */

/******************************************************************************
Function Name	:	System_Init
Engineer      :	r54940
Date          :	12/09/08

Parameters		:	
Returns			  :	NONE
Notes         :	Configures system registers and I/O
******************************************************************************/
void System_Init(void)
{

//  IRQSC = OFF;
  SPMSC1 = 0x00;
 // For Stop2
 // SPMSC2_PPDC = 1;
  SPMSC2 = OFF;
  SPMSC3 = OFF;
  SOPT1 = 0x23;          /* Enable Stop Mode, Disable COP */
  SCGC1 = 0xFF;          
  SCGC2 = 0xFF;
  APCTL1 = 0xff; 
  APCTL2 = 0xFF;

////////////////////////////////////////////////////////////////////////////  
// Init IRQ
////////////////////////////////////////////////////////////////////////
     IRQSC_IRQPE = 1;    // enable IRQ pin
     IRQSC_IRQIE = 1;    // causes an interrupt
     IRQSC_IRQPDD = 0;   // pull up 0=dis/1=enabled
     IRQSC_IRQACK = 1;

////////////////////////////////////////////////////////////////////////////  
// Init VREF Module
////////////////////////////////////////////////////////////////////////
  VREFSC1_MODE1 = 3;          // enable and output VREF in 80 pin
  VREFSC1_VREFEN1 = 1;
 // VREFSC2_MODE1 = 3;          // enable and output VREF in 64 pin
  VREFSC2_VREFEN2 = 1;

////////////////////////////////////////////////////////////////////////////  
// Init TOD
////////////////////////////////////////////////////////////////////////
  
  TODC_TODCLKS = 0;
  TODC_TODPS = 1;
  TODC_TODEN =1;
  
  /* disable all pull ups */
  PTAPE = ON;
  PTBPE = ON;
  PTCPE = OFF;
  PTDPE = ON;
  PTEPE = ON;
  
  /* low drive strength */
  PTADS = OFF;
  PTBDS = OFF;
  PTCDS = OFF;
  PTDDS = OFF;
  PTEDS = OFF;
  
  /* disable slew rate */
  PTASE = OFF;
  PTBSE = OFF;
  PTCSE = OFF;
  PTDSE = OFF;
  PTESE = OFF;
  
  PTAD = CLEAR;
  PTBD = CLEAR;
  PTCD = CLEAR;
  PTDD = CLEAR;
  PTED = CLEAR;
   
  PTADD = 0x3f;
  PTBDD = SET;
  PTCDD = 0x7f;
  PTDDD = SET;
  PTEDD = SET;

}



/////////////////////////////////////////////////////////////////////////////////////////
// KBI_ISR
// --------------------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////////////////
interrupt VectorNumber_Vkeyboard void KBI_ISR(void){
 

  if (PTAD_PTAD7 == 0)
    {
    while(PTAD_PTAD7 ==0);
    while(PTAD_PTAD7 ==0);
    if(PTAD_PTAD7 ==1){
      
    if(state >=2){
    state =0 ;
    }else {
      state = state +1 ;
    }
    } 
    }
  
  
  
  
  //clear KBF
  KBISC_KBACK = 1;
  
}
/*******************************************************************************
 * Interrupt:       IRQ_ISR
 *
 * Description:     IRQ isr handler
 *
 * Returns:         increase channel number
 *
 * Notes:           range 0x04 to 0x1f
 *
 *******************************************************************************/
interrupt VectorNumber_Virq void IRQ_ISR(void){
 
  
  if (PTCD_PTCD7 == 0)
    {
    while(PTCD_PTCD7 ==0);
    while(PTCD_PTCD7 ==0);
    if(PTCD_PTCD7 ==1){
    

  if (channel_adc > 0x1E){
      channel_adc = 0x00;
  }else {
      channel_adc = channel_adc+1;    
  }
      //Single ended skip ADC channels 1 thru 3 Plus 8,9 and 0x0d through 0x19
  if (channel_adc == 0x01){
      channel_adc = 0x04 ;
  }
  if(channel_adc == 0x08){
      channel_adc = 0x0a;
  }
  if (channel_adc == 0x0D){
      channel_adc = 0x1A;
  }

  
    }

  //clear IRQ Flag
  IRQSC_IRQACK = 1;
  
    }
}
/////////////////////////////////////////////////////////////////////////////////////////
// TOD_ISR
// --------------------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////////////////
interrupt VectorNumber_Vtod void tod_ISR(void){
                TODSC_SECF = 1; 
                PTAD_PTAD0 = ~PTAD_PTAD0;
                LCDWF22= ~LCDWF22 ;
       sec = sec +1;
       
       if(sec ==10) {
       tsec = tsec +1;
       sec =0; 
       
       }
       if(tsec ==6){
       mins = mins +1;
       tsec = 0;
       }
       
       if (mins == 10){
       tmins = tmins +1;
       mins =0;
       
       }
       if(tmins == 6){
       hour = hour +1;
       tmins = 0;
       }
       
       if(hour  == 10){
       thour = thour +1;
       hour  = 0;
       }
       
       if ((thour == 2)&&(hour ==4)){
       thour = 0;
       hour = 0 ;
       
       }
  
}

/////////////////////////////////////////////////////////////////////////////////////////
// TPM_ISR
// --------------------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////////////////

interrupt VectorNumber_Vtpm1ch0 void timer1_CH0(void)
{
  
  // Clear CH0F flag
  TPM1C0SC &=0x7F;
 
  //Clear the 16-bit timer1 counter
  TPM1CNTH = 0x00;
  
}