/******************************************************************************		
*                                                                                   	
*       Copyright (C) 2006 Freescale Semiconductor, Inc.                            	
*       All Rights Reserved								              				
*														              					
* Filename:       MCG_DRV.C               											
*														              					
* Description:	  MCG Driver files for MC9S08DZ60	        	    	
*                 based on Specification Rev. 0.9  	       						
*																						
* Notes:        																		
*  ***********************************************************************  			
*  *  THIS CODE IS ONLY INTENDED AS AN EXAMPLE OF CODE FOR THE           *  	 		
*  *  CODEWARRIOR COMPILER AND HAS ONLY BEEN GIVEN A MIMIMUM             *  	 		
*  *  LEVEL OF TEST. IT IS PROVIDED 'AS SEEN' WITH NO GUARANTEES         *  	 		
*  *  AND NO PROMISE OF SUPPORT.                                         *  	 		
*  ***********************************************************************  	 		
*																						
* Freescale reserves the right to make changes without further notice to any			
* product herein to improve reliability, function, or design. Freescale does	 		
* not assume any  liability arising  out  of the  application or use of any 	 		
* product,  circuit, or software described herein;  neither  does it convey 	 		
* any license under its patent rights  nor the  rights of others.  Freescale	 		
* products are not designed, intended,  or authorized for use as components 	 		
* in  systems  intended  for  surgical  implant  into  the  body, or  other 	 		
* applications intended to support life, or  for any  other application  in 	 		
* which the failure of the Freescale product  could create a situation where	 		
* personal injury or death may occur. Should Buyer purchase or use Freescale	 		
* products for any such intended  or unauthorized  application, Buyer shall 	 		
* indemnify and  hold  Freescale  and its officers, employees, subsidiaries,	 		
* affiliates,  and distributors harmless against all claims costs, damages, 	  		
* and expenses, and reasonable  attorney  fees arising  out of, directly or 	 		
* indirectly,  any claim of personal injury  or death  associated with such 	 		
* unintended or unauthorized use, even if such claim alleges that  Freescale	 		
* was negligent regarding the  design  or manufacture of the part. Freescale	 		
* and the Freescale logo* are registered trademarks of Freescale Ltd.       	 		
******************************************************************************/		

/* include files */

#include "MCF51EM256.H" /* include peripheral declarations */
#include "target.h"
#include "mcg_drv.h"

unsigned char MCG_MODE=FEI;

/******************************************************************************
Task Name		:	MCG_Config2
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Configures the ICG module.
******************************************************************************/

void MCG_Config (unsigned char new_mode, unsigned char mcgcr1, 
                 unsigned char mcgcr2, unsigned char mcgcr3)
{
  switch (MCG_MODE) {

    case FBI:
      
      switch (new_mode) {
      
        case FBI:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBI;
          break;
        
        case FBE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBE;
          break;
          
        case BLPI:
          Enter_BLPI(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPI;
          break;
          
        case BLPE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPE;
          break;
        
        case PBE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PBE;
          break;

        case FEE:
          Enter_FEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEE;
          break;
        
        case FEI:
          Enter_FEI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEI;
          break;
        
        case PEE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PEE;
          break;          

      }        
      break; /* End of FBI Switch */

    case FBE:
    
      switch (new_mode) {
      
        case FBI:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBI;
          break;

        case FBE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBE;
          break;

        case BLPI:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPI(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPI;
          break;
        
        case BLPE:
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPE;
          break;        

        case PBE:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PBE;
          break;

        case FEE:
          Enter_FEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEE;
          break;
        
        case FEI:
          Enter_FEI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEI;
          break;
        
        case PEE:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PEE;
          break;
        
      } 
      break; /* End of FBE Switch */

    case BLPI:
    
      switch (new_mode) {

        case FBI:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBI;
          break;
        
        case FBE:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBE;
          break;
        
        case BLPI:
          Enter_BLPI(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPI;
          break;
          
        case BLPE:
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPE;
          break;
          
        case PBE:
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PBE;
          break;

        case FEE:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          Enter_FEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEE;
          break;
        
        case FEI:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          Enter_FEI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEI;
          break;
        
        case PEE:
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PEE;
          break;        
          
      } 
      break; /* End of BLPI Switch */

    case BLPE:
    
      switch (new_mode) {

        case FBI:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBI;
          break;
        
        case FBE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBE;
          break;
        
        case BLPI:
          Enter_BLPI(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPI;
          break;
          
        case BLPE:
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPE;
          break;
          
        case PBE:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PBE;
          break;

        case FEE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEE;
          break;
        
        case FEI:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FEI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEI;
          break;
        
        case PEE:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PEE;
          break;
        
      } 
      break; /* End of BLPE Switch */

    case PBE:
    
      switch (new_mode) {

        case FBI:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBI;
          break;
        
        case FBE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBE;
          break;
        
        case BLPI:
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPI(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPI;
          break;
          
        case BLPE:
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPE;
          break;
        
        case PBE:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PBE;
          break;

        case FEE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEE;
          break;
        
        case FEI:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FEI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEI;
          break;
        
        case PEE:
          Enter_PEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PEE;
          break;

      } 
      break; /* End of PBE Switch */

    case FEE:
      
      switch (new_mode) {

        case FBI:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBI;
          break;
        
        case FBE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBE;
          break;
          
        case BLPI:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPI(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPI;
          break;

        case BLPE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPE;
          break;
                  
        case PBE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PBE;
          break;

        case FEE:
          Enter_FEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEE;
          break;
        
        case FEI:
          Enter_FEI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEI;
          break;
        
        case PEE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PEE;
          break;
                  
      }        
      break; /* End of FEE Switch */

    case FEI:
    
      switch (new_mode) {

        case FBI:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBI;
          break;
        
        case FBE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBE;
          break;
        
        case BLPI:
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPI(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPI;
          break;
          
        case BLPE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPE;
          break;
        
        case PBE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PBE;
          break;

        case FEE:
          Enter_FEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEE;
          break;
        
        case FEI:
          Enter_FEI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEI;
          break;
        
        case PEE:
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_PEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PEE;
          break;
        
      } 
      break; /* End of FEI Switch */

    case PEE:
    
      switch (new_mode) {

        case FBI:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FBI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBI;
          break;
        
        case FBE:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FBE;
          break;
        
        case BLPI:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPI(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPI;
          break;
          
        case BLPE:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_BLPE(mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = BLPE;
          break;
                 
        case PBE:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PBE;
          break;

        case FEE:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEE;
          break;
               
        case FEI:
          Enter_PBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FBE (mcgcr1,mcgcr2,mcgcr3);
          Enter_FEI (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = FEI;
          break;
        
        case PEE:
          Enter_PEE (mcgcr1,mcgcr2,mcgcr3);
          MCG_MODE = PEE;
          break;

      } 
      break; /* End of PEE Switch */

  }
}

/******************************************************************************
Task Name		:	MCG_Config_old
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Configures the ICG module.
******************************************************************************/

void MCG_Config_old(unsigned char mcgcr1, unsigned char mcgcr2, unsigned char mcgcr3)
{
    MCGC1 = mcgcr1;	
    MCGC2 = mcgcr2;
    MCGC3 = mcgcr3;
    	
    	/* Wait until external oscillator is initialized */
   	if (MCGC2_EREFS==1) while (! MCGSC_OSCINIT );
    	
    	/* Wait for PLL/FLL status to update */
    while (MCGSC_PLLST != MCGC3_PLLS);

    	/* Wait for Reference clock status to update */
    while (MCGSC_IREFST != MCGC1_IREFS);
    
      /* Wait for Clock status to update */
    if ((MCGC3_PLLS==1) & (MCGC1_CLKS==0b00)) while (MCGSC_CLKST != !MCGC1_CLKS);
    else while (MCGSC_CLKST != MCGC1_CLKS);
}

/******************************************************************************
Task Name		:	Enter_FEE
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Changes the MCG mode to FEE.
******************************************************************************/

void Enter_FEE(unsigned char mcgcr1, unsigned char mcgcr2, unsigned char mcgcr3)
{
      /* Update MCG Control Register 2 */
    MCGC2 = (mcgcr2&(~LP));
    	
    	/* Wait until external oscillator is initialized */
   	if (MCGC2_EREFS==1) while (!MCGSC_OSCINIT );
    
      /* Update MCG Control Register 3 and Select FLL */
    MCGC3 = (mcgcr3&(~PLLS));

    	/* Wait for FLL status to update */
    while (MCGSC_PLLST);
    
      /* Update MCG Control Register 1, Select External Reference Clock, Clock Source = FLL */
    MCGC1 = (mcgcr1&(~CLKS)&(~IREFS));

    	/* Wait for Reference clock status to indicate External Clock  */
    while (MCGSC_IREFST);
    
      /* Wait for Clock status to indicate FLL output */
    while (MCGSC_CLKST != MCGC1_CLKS);
    
      /* Wait for LOCK bit to set */
    while (!MCGSC_LOCK); 
}

/******************************************************************************
Task Name		:	Enter_FBE
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Changes the MCG mode to FBE from FEI, FBI, FEE, PBE or BLPE.
******************************************************************************/

void Enter_FBE(unsigned char mcgcr1, unsigned char mcgcr2, unsigned char mcgcr3)
{
      /* Update MCG Control Register 2 */
    MCGC2 = (mcgcr2&(~LP));

    	/* Wait until external oscillator is initialized */
   	if (MCGC2_EREFS==1) while (!MCGSC_OSCINIT );
        
      /* Update MCG Control Register 3 and Select FLL */
    MCGC3 = (mcgcr3&(~PLLS));

    	/* Wait for FLL status to update */
    while (MCGSC_PLLST);
    
      /* Update MCG Control Register 1, Clock Source = External Reference */
    MCGC1 = ((mcgcr1|EXTERNAL_OUTPUT)&(~CLKS0));
    
      /* Wait for Clock status to indicate External Reference Clock */
    while (MCGSC_CLKST != MCGC1_CLKS);
}

/******************************************************************************
Task Name		:	Enter_FBI
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Changes the MCG mode to FBI from FBE, FEE or FEI.
******************************************************************************/

void Enter_FBI(unsigned char mcgcr1, unsigned char mcgcr2, unsigned char mcgcr3)
{
      /* Update MCG Control Register 2 */
    MCGC2 = (mcgcr2&(~LP));

      /* Update MCG Control Register 3 and Select FLL */
    MCGC3 = (mcgcr3&(~PLLS));

    	/* Wait for FLL status to update */
    while (MCGSC_PLLST);
    
      /* Update MCG Control Register 1, Clock Source = Internal Reference */
    MCGC1 = ((mcgcr1|INTERNAL_OUTPUT)&(~CLKS1));
    
      /* Wait for Clock status to indicate Internal Reference Clock */
    while (MCGSC_CLKST != MCGC1_CLKS);
}

/******************************************************************************
Task Name		:	Enter_FEI
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Changes the MCG mode to FEI from FBE, FBI, or FEI.
******************************************************************************/

void Enter_FEI(unsigned char mcgcr1, unsigned char mcgcr2, unsigned char mcgcr3)
{
      /* Update MCG Control Register 2 */
    MCGC2 = (mcgcr2&(~LP));
    	
      /* Update MCG Control Register 3 and Select FLL */
    MCGC3 = (mcgcr3&(~PLLS));

    	/* Wait for FLL status to update */
    while (MCGSC_PLLST);
    
      /* Update MCG Control Register 1, Select Internal Reference Clock, Clock Source = FLL */
    MCGC1 = ((mcgcr1&(~CLKS))|IREFS);

    	/* Wait for Reference clock status to indicate Internal Clock */
    while (!MCGSC_IREFST);
    
      /* Wait for Clock status to indicate FLL output */
    while (MCGSC_CLKST != MCGC1_CLKS);
    
      /* Wait for LOCK bit to set */
    while (!MCGSC_LOCK); 
}

/******************************************************************************
Task Name		:	Enter_PBE
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Changes the MCG mode to PBE from FBE, PEE or BLPE.
******************************************************************************/

void Enter_PBE(unsigned char mcgcr1, unsigned char mcgcr2, unsigned char mcgcr3)
{
      /* Update MCG Control Register 2 */
    MCGC2 = (mcgcr2&(~LP));

    	/* Wait until external oscillator is initialized */
   	if (MCGC2_EREFS==1) while (!MCGSC_OSCINIT );
        
      /* Update MCG Control Register 1, Select External Reference Clock, Clock Source = External Reference */
    MCGC1 = (((mcgcr1|EXTERNAL_OUTPUT)&(~CLKS0))&(~IREFS));
    
      /* Update MCG Control Register 3 and Select PLL */
    MCGC3 = (mcgcr3|PLLS);
    
    	/* Wait for PLL status to update */
    while (!MCGSC_PLLST);
    
      /* Wait for Clock status to indicate External Reference Clock */
    while (MCGSC_CLKST != MCGC1_CLKS);
}

/******************************************************************************
Task Name		:	Enter_PEE
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Changes the MCG mode to PEE from PBE.
******************************************************************************/

void Enter_PEE(unsigned char mcgcr1, unsigned char mcgcr2, unsigned char mcgcr3)
{
      /* Update MCG Control Register 2 */
    MCGC2 = (mcgcr2&(~LP));

    	/* Wait until external oscillator is initialized */
   	if (MCGC2_EREFS==1) while (!MCGSC_OSCINIT );
        
      /* Update MCG Control Register 1, Select External Reference Clock, Clock Source = PLL */
    MCGC1 = (mcgcr1&(~CLKS)&(~IREFS));
    
      /* Update MCG Control Register 3 and Select PLL */
    MCGC3 = (mcgcr3|PLLS);
    
    	/* Wait for PLL status to update */
    while (!MCGSC_PLLST);
    
      /* Wait for Clock status to indicate PLL output */
    while (MCGSC_CLKST != (!MCGC1_CLKS));

      /* Wait for LOCK bit to set */
    while (!MCGSC_LOCK); 
}

/******************************************************************************
Task Name		:	Enter_BLPE
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Changes the MCG mode to BLPE from FBE, BLPI or PBE.
******************************************************************************/

void Enter_BLPE(unsigned char mcgcr1, unsigned char mcgcr2, unsigned char mcgcr3)
{
      /* Disable the FLL/PLL */
    MCGC2_LP = 1;

    MCGC2_ERCLKEN = 1;
      /* Enable External Oscillator */    
    MCGC2_EREFS=1;
            
    	/* Wait until external oscillator is initialized */
   	while (!MCGSC_OSCINIT );
        
      /* Update MCG Control Register 1, Clock Source = External Reference */
    MCGC1 = ((MCGC1|EXTERNAL_OUTPUT)&(~CLKS0));

//   	while (!MCGSC_OSCINIT );
    
      /* Wait for Clock status to indicate External Reference Clock */
    while (MCGSC_CLKST != MCGC1_CLKS);
}

/******************************************************************************
Task Name		:	Enter_BLPI
Engineer		:	Gordon Borland 
Date			  :	28/03/06

Notes			:	Changes the MCG mode to BLPI from FBI or BLPE.
******************************************************************************/

void Enter_BLPI(unsigned char mcgcr1, unsigned char mcgcr2, unsigned char mcgcr3)
{
      /* Update MCGC2 and Disable the FLL/PLL */
    MCGC2 = (mcgcr2|LP);
            
      /* Update MCG Control Register 1, Clock Source = Internal Reference */
    MCGC1 = ((MCGC1|INTERNAL_OUTPUT)&(~CLKS1));
    
      /* Wait for Clock status to indicate Internal Reference Clock */
    while (MCGSC_CLKST != MCGC1_CLKS);
}