/******************************************************************************		
*                                                                                   	
*       Copyright (C) 2006 Freescale Semiconductor, Inc.                            	
*       All Rights Reserved								              				
*														              					
* Filename:     MC9S08DZ60.C               											
*														              					
* Description:	  MCG Header files for MC9S08DZ60	        	    	
*                 based on Specification Rev. 0.9  	       						
*																						
* Notes:        																		
*  ***********************************************************************  			
*  *  THIS CODE IS ONLY INTENDED AS AN EXAMPLE OF CODE FOR THE           *  	 		
*  *  METROWERKS COMPILER AND HAS ONLY BEEN GIVEN A MIMIMUM              *  	 		
*  *  LEVEL OF TEST. IT IS PROVIDED 'AS SEEN' WITH NO GUARANTEES         *  	 		
*  *  AND NO PROMISE OF SUPPORT.                                         *  	 		
*  ***********************************************************************  	 		
*																						
* Freescale reserves the right to make changes without further notice to any			
* product herein to improve reliability, function, or design. Freescale does	 		
* not assume any  liability arising  out  of the  application or use of any 	 		
* product,  circuit, or software described herein;  neither  does it convey 	 		
* any license under its patent rights  nor the  rights of others.  Freescale	 		
* products are not designed, intended,  or authorized for use as components 	 		
* in  systems  intended  for  surgical  implant  into  the  body, or  other 	 		
* applications intended to support life, or  for any  other application  in 	 		
* which the failure of the Freescale product  could create a situation where	 		
* personal injury or death may occur. Should Buyer purchase or use Freescale	 		
* products for any such intended  or unauthorized  application, Buyer shall 	 		
* indemnify and  hold  Freescale  and its officers, employees, subsidiaries,	 		
* affiliates,  and distributors harmless against all claims costs, damages, 	  		
* and expenses, and reasonable  attorney  fees arising  out of, directly or 	 		
* indirectly,  any claim of personal injury  or death  associated with such 	 		
* unintended or unauthorized use, even if such claim alleges that  Freescale	 		
* was negligent regarding the  design  or manufacture of the part. Freescale	 		
* and the Freescale logo* are registered trademarks of Freescale Ltd.       	 		
******************************************************************************/		
/******************************************************************************/
#ifndef MCG_DRV_H        /*prevent duplicated includes*/
#define MCG_DRV_H

/************************* Project Include Files *****************************/


/************************* #Defines ******************************************/

#define FBI 0x04
#define FBE 0x08
#define BLPI 0x0C
#define BLPE 0x22
#define PBE 0x2C
#define FEE 0x40
#define FEI 0x50
#define PEE 0x6C

/* MCG Control Register 1 */
#define FLL_PLL_OUTPUT 0x00
#define INTERNAL_OUTPUT 0x40
#define EXTERNAL_OUTPUT 0x80
#define RDIV_BY_1 0x00
#define RDIV_BY_2 0x08
#define RDIV_BY_4 0x10
#define RDIV_BY_8 0x18
#define RDIV_BY_16 0x20
#define RDIV_BY_32 0x28
#define RDIV_BY_64 0x30
#define RDIV_BY_128 0x38
#define INTERNAL_REF 0x04
#define EXTERNAL_REF 0x00
#define MCGIRCLK_ON 0x02
#define MCGIRCLK_OFF 0x00
#define INTERNAL_STOP_ENABLE 0x01
#define INTERNAL_STOP_DISABLE 0x00
#define MCGC1_DEFAULT 0x04

#define CLKS 0xC0
#define CLKS1 0x80
#define CLKS0 0x40
#define RDIV 0x38
#define RDIV2 0x20
#define RDIV1 0x10
#define RDIV0 0x08
#define IREFS 0x04
#define IRCLKEN 0x02
#define IREFSTEN 0x01

/* MCG Control Register 2 */
#define BDIV_BY_1 0x00
#define BDIV_BY_2 0x40
#define BDIV_BY_4 0x80
#define BDIV_BY_8 0xC0
#define HI_FREQ 0x20
#define LO_FREQ	0x00
#define HI_GAIN	0x10
#define LO_GAIN	0x00
#define LO_POWER_MODE 0x08
#define EXT_OSC 0x04
#define EXT_CLOCK 0x00
#define MCGERCLK_ON 0x02
#define MCGERCLK_OFF 0x00
#define EXTERNAL_STOP_ENABLE 0x01
#define EXTERNAL_STOP_DISABLE 0x00
#define MCGC2_DEFAULT 0x40

#define BDIV 0xC0
#define BDIV1 0x80
#define BDIV0 0x40
#define RANGE 0x20
#define HGO 0x10
#define LP 0x08
#define EREFS 0x04
#define ERCLKEN 0x02
#define EREFSTEN 0x01

/* MCG Status and Control Register */
#define LOLS 0x80
#define LOCK 0x40
#define PLLST 0x20
#define FLL_OUTPUT_STATUS 0x00
#define INT_OUTPUT_STATUS 0x04
#define EXT_OUTPUT_STATUS 0x80
#define PLL_OUTPUT_STATUS 0x0C
#define OSC_INIT 0x02

/* MCG Control Register 3 */
#define LOSS_OF_LOCK_IRQ 0x80
#define PLL 0x40
#define FLL 0x00
#define CLOCK_MONITOR_ON 0x20
#define VDIV_X_4 0x01
#define VDIV_X_8 0x02
#define VDIV_X_12 0x03
#define VDIV_X_16 0x04
#define VDIV_X_20 0x05
#define VDIV_X_24 0x06
#define VDIV_X_28 0x07
#define VDIV_X_32 0x08
#define VDIV_X_36 0x09
#define VDIV_X_40 0x0A
#define MCGC3_DEFAULT 0x01

#define LOLIE 0x80
#define PLLS 0x40
#define CME 0x20
#define VDIV 0x0F
#define VDIV3 0x08
#define VDIV2 0x04
#define VDIV1 0x02
#define VDIV0 0x01


/************************* Project Include Files ******************************/


/************************* typedefs ******************************************/


/************************* Global Variables **********************************/

extern unsigned char MCG_MODE;

/************************* Macros ********************************************/


/************************* Prototypes ****************************************/

void MCG_Config(unsigned char, unsigned char, unsigned char, unsigned char);
void MCG_Config_old(unsigned char, unsigned char, unsigned char);
void Enter_FBI(unsigned char, unsigned char, unsigned char);
void Enter_FBE(unsigned char, unsigned char, unsigned char);
void Enter_BLPI(unsigned char, unsigned char, unsigned char);
void Enter_BLPE(unsigned char, unsigned char, unsigned char);
void Enter_PBE(unsigned char, unsigned char, unsigned char);
void Enter_FEE(unsigned char, unsigned char, unsigned char);
void Enter_FEI(unsigned char, unsigned char, unsigned char);
void Enter_PEE(unsigned char, unsigned char, unsigned char);

#endif /* MCG_DRV_H */
